/* diacaux.c
 * to be linked with lex.yy.c from diac.l
 * written by Dorai Sitaram, Rice University, 1990
 */

#include "diacaux.h"
#include <stdio.h>

int slen(s)
char *s;
{
  int i;

  for (i = 1; s[i] != '\0'; i++)
	;
  return i+1;
}

char *strap(s,t)
char *s,*t;
{
  char *r = (char *) malloc(slen(s) + slen(t));
  int i,j;
  for (i = 0; s[i] != '\0'; i++)
	r[i] = s[i];

  for (j = 0; t[j] != '\0'; i++, j++)
	r[i] = t[j];

  r[i] = '\0';
  return r;
}


char *getfilename(s)
char *s;
{
  char *r = (char *) malloc(slen(s));
  int i,j;

  for (i = 0; s[i] == ' ' || s[i] == '\t' || s[i] == '\n'; i++) 
	;

  for (j = 0; s[i] != '\0'; i++, j++)
	r[j] = s[i];

  r[j] = '\0';


  if ( r[j-4] != '.' )  return strap(r,".tex");
  else return r;
}
			
char *getfilenamebrack(s)
char *s;
{
  char *r = (char *) malloc(slen(s));
  int i,j;
  for (i = 0; s[i] == ' ' || s[i] == '\t' || s[i] == '\n' || 
		s[i] == '{'; i++)
	;

  for (j = 0; s[i] != '}'; i++, j++)
	r[j] = s[i];

  r[j] = '\0';

  if ( r[j-4] != '.' )  return strap(r,".tex");
  else return r;
}

char *maketempfilename(s)
char *s;
{
  char *r = (char *)malloc(slen(s));
  int i;
  for (i = 0; s[i] != '\0'; i++) {
	r[i] = s[i];
	if (r[i] == '/') r[i] = '_';
  }

  r[i] = '\0';
  return strap("/usr/tmp/",r);
}

void dosubdiac(texfile,tempfile,fmt)
char *texfile,*tempfile,*fmt;
{
 FILE* test;
/*  system(strap("diact <", strap(texfile, strap(" > ", tempfile)))); */
  if ((test = fopen(texfile,"r")) != NULL) {
     printf("%%%%%% START OF "); printf(fmt,texfile);
     fflush(stdout);
     system(strap("diact <", texfile));
     printf("%%%%%% END OF "); printf(fmt,texfile);
  }
  else {
     printf(fmt,texfile);
  }
}
